unit uFrmMain;

interface

uses
  System.SysUtils, Vcl.Forms, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs,
  Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls, WEBLib.Controls, WEBLib.ExtCtrls,
  uSubForm1, uSubForm2, WEBLib.Buttons;

Type
 TThenProc = Reference to Procedure;

type
  TFrmMain = class(TWebForm)
    WebLabel1: TWebLabel;
    btCreateSubF1: TWebButton;
    HostPanel: TWebPanel;
    btCreateSubF2: TWebButton;
    WebLabel2: TWebLabel;
    WebLabel3: TWebLabel;
    WebLabel4: TWebLabel;
    TimerContinueWith: TWebTimer;
    procedure btCreateSubF1Click(Sender: TObject);
    procedure btCreateSubF2Click(Sender: TObject);
    procedure TimerContinueWithTimer(Sender: TObject);
  private
    FContProc : TThenProc;
    procedure ContinueWith(ContinueProc: TThenProc);
  public
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

Uses Web;

procedure TFrmMain.btCreateSubF1Click(Sender: TObject);

  procedure AfterCreate(AForm: TObject);
  begin
   Console.log('Actually, this is not AFTER Form1.Create but in fact BEFORE Form1.Create, right?');
   Console.log('Form1.Name in AfterCreate:','"'+SubForm1.Name+'"','Now it seems fully created');
  end;

  Procedure ShowForm;
  Begin
  If not assigned(SubForm1) then
   Begin
    Console.log('Form1 does not exist, so create it');
    SubForm1 := TSubForm1.CreateNew(HostPanel.ElementID, @AfterCreate);
    Console.log('Form1.Name after CreateNew():','"'+SubForm1.Name+'"','Is empty, so Form1 not completed yet somehow...');
   End
  Else
   Begin
    Console.log('Form1 does exist');
    If not SubForm1.Visible then
     Begin
      Console.log('Form1 is not visible');
      Console.log('Setting Form1.Visible := True');
      SubForm1.Visible := True;
     End
    Else Console.log('Form1 is already visible');
   End;
  End;

  Procedure AfterHide;
  Begin
   Console.log('After Form2 supposed to be hidden');
   ShowForm;
  End;

begin
  Console.log('...');
  Console.log('Button 1 clicked');
  Console.log('...');

  If assigned(SubForm2) and SubForm2.Visible then
   Begin
    Console.log('Form2 exists and is visible');
    Console.log('Setting Form2.Visible := False');
    SubForm2.Visible := False;
    ContinueWith(@AfterHide);
   End
  Else
   Begin
    Console.log('Nothing to do with Form2');
    ShowForm;
   End
end;

{-------------------------------}

procedure TFrmMain.btCreateSubF2Click(Sender: TObject);

  procedure AfterCreate(AForm: TObject);
  begin
   Console.log('Actually, this is not AFTER Form2.Create but in fact BEFORE Form2.Create, right?');
   Console.log('Form2.Name in AfterCreate:','"'+SubForm2.Name+'"','Now it seems fully created');
  end;

  Procedure ShowForm;
  Begin
   If not assigned(SubForm2) then
    Begin
     Console.log('Form2 does not exist, so create it');
     SubForm2 := TSubForm2.CreateNew(HostPanel.ElementID, @AfterCreate);
     Console.log('Check Form2.Name after CreateNew():','"'+SubForm2.Name+'"','Is empty, so Form2 not completed yet somehow...');
    End
   Else
    Begin
     Console.log('Form2 does exist');
     If not SubForm2.Visible then
      Begin
       Console.log('Form2 is not visible');
       Console.log('Setting Form2.Visible := True');
       SubForm2.Visible := True;
      End
     Else Console.log('Form2 is already visible');
    End;
  End;

  Procedure AfterHide;
  Begin
   Console.log('After Form1 supposed to be hidden');
   ShowForm;
  End;

begin
  Console.log('...');
  Console.log('Button 2 clicked');
  Console.log('...');

  If assigned(SubForm1) and SubForm1.Visible then
   Begin
    Console.log('Form1 exists and is visible');
    Console.log('Setting Form1.Visible := False');
    SubForm1.Visible := False;
    ContinueWith(@AfterHide);
   End
  Else
   Begin
    Console.log('Nothing to do with Form2');
    ShowForm;
   End

end;

{-------------------------------}

Procedure TFrmMain.ContinueWith(ContinueProc : TThenProc);
Begin
  FContProc := ContinueProc;
  TimerContinueWith.Interval := 1;
  TimerContinueWith.Enabled := True;
End;

{---------------------------------------}

Procedure TFrmMain.TimerContinueWithTimer(Sender: TObject);
Begin
  TimerContinueWith.Enabled := False;
  If assigned(FContProc) then FContProc;
End;

{---------------------------------------}


end.
